package ru.ifmo.control;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

/**
 * ,    .
 */
public class DrawPane extends JComponent implements MouseMotionListener {
	/**
	 *   .
	 */
	public static GameData data = null;
	
	private BufferedImage buf = null;
	private Graphics2D g2 = null;
	private Toolkit toolkit;
	
	private int width = 800;
	private int height = 600;
	
	/**
	 *      .
	 */
	public DrawPane() {
        super();
        setBackground(Color.orange);
		setOpaque(true);
		setDoubleBuffered(true);
		
		setPreferredSize(new Dimension(width, height));
		setSize(width, height);
		toolkit = getToolkit();
		
		data = new GameData(this);
		
		addMouseMotionListener(this);
    }

	public void paint(Graphics g) {
		if (buf == null || width != getWidth() || height != getHeight()) {
			buf = (BufferedImage)createImage(width = getWidth(), height = getHeight());
			g2 = buf.createGraphics();
			g2.setBackground(getBackground());
			g2.clearRect(0, 0, width, height);
		}

    	g2.clearRect(0, 0, width, height);
		data.paintAll(g2);
		
		g.drawImage(buf, 0, 0, width, height, this);
		toolkit.sync();
	}

	public void mouseDragged(MouseEvent e) {}

	public void mouseMoved(MouseEvent e) {
		data.mouseX = e.getX();
		data.mouseY = e.getY();
	}
}
