package ru.ifmo.control;

import javax.swing.JApplet;

import ru.ifmo.control.event.UserEventProvider;

import unimod.GameModelEventProcessor;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.runtime.ModelEngine;

public class GameApplet extends JApplet {
	
	ModelEngine engine;
	
	public void init() {
		GameGUI.initApplet(this);
		
		try {
			engine = GameModelEventProcessor.createModelEngine(true);
		} catch (CommonException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public void start() {
		try {
			engine.start();
		} catch (CommonException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public void stop() {
		try {
			UserEventProvider.fireEventAndWait(UserEventProvider.E4);
		} catch (IllegalStateException e) {
			System.exit(0);
		}
	}
	
}
