package ru.ifmo.control;

import java.awt.Component;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.Random;

import ru.ifmo.image.Car;
import ru.ifmo.image.RotatableImage;
import ru.ifmo.image.Stone;

/**
 *         . 
 */
public class Nature {
	
	private String[] files = {"/stone1.png", "/stone2.png", "/stone3.png",
			"/cactus1.gif", "/cactus2.gif", "/cactus3.gif"};
	
	/**
	 *    
	 */
	protected Stone[] stones = new Stone[30];
	
	Component drawPane;

	/**
	 *  .
	 * @param parent  
	 * @param filepath         
	 * @throws IOException       
	 */
	public Nature(Component parent, String filepath, Car playerCar) throws IOException {
		BufferedImage[] images = new BufferedImage[files.length];
		for (int i = 0; i < images.length; i++) {
			images[i] = RotatableImage.loadImage(parent, filepath + files[i]);
		}
		
		Random rand = new Random();
		for (int i = 0; i < stones.length; i++) {
			stones[i] = new Stone(parent, playerCar);
			stones[i].setImage(images[rand.nextInt(images.length)]);
			
			stones[i].setDirectionAngle(rand.nextDouble() * 2 * Math.PI);
			stones[i].setLocation(rand.nextInt(Stone.maxX), rand.nextInt(Stone.maxY));
		}
		
		drawPane = parent;
	}

	/**
	 *     .
	 * @param g <code>Graphics2D</code> 
	 * @deprecated
	 */
	public void clearDrawArea(Graphics2D g) {
		for (Stone img: stones) {
			img.clearDrawArea(g);
		}
	}
		
	/**
	 *     .
	 * @param g <code>Graphics2D</code>  
	 */
	public void paint(Graphics2D g) {
		for (Stone img: stones) {
			img.paint(g);
		}
	}
}
