package ru.ifmo.control.event;

import java.util.HashMap;
import java.util.Iterator;

import ru.ifmo.control.DrawPane;
import ru.ifmo.control.GameData;
import ru.ifmo.control.manager.CarManager;
import ru.ifmo.image.EnemyCar;

import com.evelopers.common.exception.CommonException;
import com.evelopers.common.exception.SystemException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.Parameter;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

/**
 *     .
 */
public class CarEventProvider implements EventProvider {

	private static HashMap<EnemyCar, ModelEngine> engines = new HashMap<EnemyCar, ModelEngine>();
	private static GameData data = null;
	private static Iterator<EnemyCar> iter = null;
	/**
	 * @unimod.event.descr start moving
	 */
	public static final String E1 = "e1";
	/**
	 * @unimod.event.descr exit program
	 */
	public static final String E2 = "e2";
	/**
	 * @unimod.event.descr do wait
	 */
	public static final String E3 = "e3";
	/**
	 * @unimod.event.descr finish manoeuvre
	 */
	public static final String E4 = "e4";
	/**
	 * @unimod.event.descr collided with another car
	 */
	public static final String E5 = "e5";
	/**
	 * @unimod.event.descr next tick heppened
	 */
	public static final String E101 = "e101";
	
	public void dispose() {}

	public void init(ModelEngine engine) throws CommonException {
		
		if (data == null) {
			data = DrawPane.data;
		}

		ControlledObject o = engine.getControlledObjectsManager().getControlledObject("o1");
		if (o instanceof CarManager) {
			if (iter == null) {
				iter = data.enemies.iterator();
			}
			EnemyCar car = iter.next();
			engines.put(car, engine);
			((CarManager)o).setData(data, car);
		} else {
			throw new SystemException("ControlledObject o1 should be instanceof CarManager!");
		}
	}
	
	/**
	 *        
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventToAll(String eventName, Parameter ... parameter) {
		for (ModelEngine e: engines.values()) {
			e.getEventManager().handle(new Event(eventName, parameter),
                    StateMachineContextImpl.create());
        }
    }
	
	
	/**
	 *    ,       .
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventLater(String eventName, Parameter ... parameter) {
		for (EnemyCar car: data.enemies) {
			engines.get(car).getEventManager().handle(new Event(eventName, parameter),
                    StateMachineContextImpl.create());
        }
    }
	
	 /**
	  *      <code>exCar</code>, 
	  *       .
	  * @param exCar ,     
	  * @param eventName  
	  * @param parameter 
	  */
	public static void fireEventExceptCar(EnemyCar exCar, String eventName, Parameter ... parameter) {
		for (EnemyCar car: data.enemies) {
			if (!car.equals(exCar))
				engines.get(car).getEventManager().handle(new Event(eventName, parameter),
	                    StateMachineContextImpl.create());
        }
    }
	
	/**
	 *       .
	 * @param car ,    .
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventLater(EnemyCar car, String eventName, Parameter ... parameter) {
		engines.get(car).getEventManager().handle(new Event(eventName, parameter),
                StateMachineContextImpl.create());
	}

	/**
	 *        .
	 * @param car ,    .
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventAndWait(EnemyCar car, String eventName, Parameter ... parameter) {
		engines.get(car).getEventManager().handleAndWait(new Event(eventName, parameter),
                StateMachineContextImpl.create());
    }
	
}
