package ru.ifmo.control.event;

import java.util.TimerTask;

import ru.ifmo.control.DrawPane;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

/**
 *   .
 */
public class ConfigurableTimer implements EventProvider{
	
	private static java.util.Timer t;
	private static ModelEngine engine;
	private static int sleepCount = 0;
	
	/**
	 * @unimod.event.descr next tick happened
	 */
	public static final String E101 = "e101";
	/**
	 * @unimod.event.descr increase score
	 */
	public static final String E102 = "e102";
	
	public void init(ModelEngine engine) {
		ConfigurableTimer.engine = engine;
	}
	
	/**
	 *   .
	 */
	public static void startNewTimer() {
		if (t != null) {
			t.cancel();
		}
		sleepCount = 0;
		t = new java.util.Timer(false);
		t.schedule(new TimerTask() {
					public void run() {
						engine.getEventManager().handle(
								new Event(E101), StateMachineContextImpl.create());
						if (++sleepCount > 30) {
							sleepCount = 0;
							engine.getEventManager().handle(
									new Event(E102), StateMachineContextImpl.create());
						}
					}
				}, 100, DrawPane.data.sleepAmount);
	}
	
	public void dispose() {
		t.cancel();
	}
}
