package ru.ifmo.control.event;

import ru.ifmo.control.GameData;
import ru.ifmo.control.manager.Manager;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.Parameter;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;

/**
 *    .   
 *   .
 */
public class GameEventProvider implements EventProvider {
	private static ModelEngine engine;
	
	public void dispose() {}

	public void init(ModelEngine engine) throws CommonException {
		if (GameEventProvider.engine != null) return;
		GameEventProvider.engine = engine;
	}

	
	/**
	 *      .
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventAndWait(String eventName, Parameter ... parameter) {
		if (engine != null) {
        	engine.getEventManager().handleAndWait(new Event(eventName, parameter),
                    StateMachineContextImpl.create());
        }
    }
	
	
	/**
	 *     .
	 * @param eventName  
	 * @param parameter 
	 */
	public static void fireEventLater(String eventName, Parameter ... parameter) {
		if (engine != null) {
        	engine.getEventManager().handle(new Event(eventName, parameter),
                    StateMachineContextImpl.create());
        }
    }
	
	/**
	 *     .
	 * @param data  
	 */
	public static void setGameData(GameData data) {
		((Manager)engine.getControlledObjectsManager().getControlledObject("o1")).setData(data);
		((Manager)engine.getControlledObjectsManager().getControlledObject("o2")).setData(data);
		((Manager)engine.getControlledObjectsManager().getControlledObject("o3")).setData(data);
	}
}
