package ru.ifmo.control.manager;

import java.awt.geom.Point2D;

import ru.ifmo.control.GameData;
import ru.ifmo.control.event.CarEventProvider;
import ru.ifmo.control.event.GameEventProvider;
import ru.ifmo.control.event.WorldEventProvider;
import ru.ifmo.image.Car;
import ru.ifmo.image.EnemyCar;

import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 *       (. CarModel.unimod)
 */
public class CarManager extends Manager {

	/**
	 *       
	 */
	protected EnemyCar myCar;
	
	/*         */
	protected Point2D player = new Point2D.Double();
	protected Point2D police = new Point2D.Double();
	
	private double rotationAngle = 0;
	private int count = 0;
	
//	public static int waitCounter = 0;
	
	
	/**
	 *         
	 * @param d  
	 * @param car  
	 */
	public void setData(GameData d, EnemyCar car) {
		data = d;
		myCar = car;
	}	
	
	/**
	 * @unimod.action.descr move
	 */
	public void z1(StateMachineContext context) {
		myCar.move();
	}
	
	/**
	 * @unimod.action.descr rotate towards player car
	 */
	public void z2(StateMachineContext context) {
		data.playerCar.getLocation(player);
		double alpha = Math.atan2((player.getY() - myCar.getY()), 
				(player.getX() - myCar.getX()));
		myCar.rotateTo(alpha);
	}
	
	/**
	 * @unimod.action.descr do manoeuvre
	 */
	public void z3(StateMachineContext context) {
		myCar.rotate(rotationAngle);
	}

	/**
	 * @unimod.action.descr will crash
	 */
	public boolean x1(StateMachineContext context) {
		for (Car c: data.enemies) {
			if (!c.equals(myCar)) {
				if (myCar.willCrash(c)) {
					double dAngle = Math.IEEEremainder(myCar.getDirectionAngle() - c.getDirectionAngle(), Math.PI *2);
					if (Math.abs(dAngle) < Math.PI / 2) {
						rotationAngle = -Math.signum(dAngle) * myCar.getMaxAngle();
					} else {
						rotationAngle = myCar.getMaxAngle();
					}
					count = 20;
					return true;
				}
			}
		}
		return false;
	}


	/**
	 * @unimod.action.descr is leave bounds
	 */
	public boolean x2(StateMachineContext context) {
		player = data.playerCar.getLocation(player);
		int h = data.drawPane.getHeight();
		int w = data.drawPane.getWidth();
		
		int d = data.invSize;
		myCar.getLocation(police);
		return ((Math.abs(police.getX() - player.getX()) > w/2+ 2*d) ||
				(Math.abs(police.getY() - player.getY()) > h/2 + 2*d));
	}

	/**
	 * @unimod.action.descr is crash
	 */
	public boolean x3(StateMachineContext context) {
		for (EnemyCar car: data.enemies) {
			if (myCar.equals(car)) continue;
			if (myCar.intersect(car)) {
				GameEventProvider.fireEventLater(WorldEventProvider.E80);
				CarEventProvider.fireEventLater(car, CarEventProvider.E5);
				return true;
			}
		}
		return false;
	}

	/**
	 * @unimod.action.descr set random location
	 */
	public void z5(StateMachineContext context) {
		myCar.setRandomLocation();
	}

	/**
	 * @unimod.action.descr draw crash
	 */
	public void z6(StateMachineContext context) {
		myCar.explode();
	}

	/**
	 * @unimod.action.descr increase score
	 */
	public void z4(StateMachineContext context) {
		GameData.score += 10;
	}

	/**
	 * @unimod.action.descr finish manoeuvre
	 */
	public boolean x4(StateMachineContext context) {
		return --count < 0;
	}

	/**
	 * @unimod.action.descr stop car immediately
	 */
	public void z7(StateMachineContext context) {
		myCar.stopCarImmediately();
	}

	/**
	 * @unimod.action.descr speed up
	 */
	public void z8(StateMachineContext context) {
		myCar.speedUp();
	}

	/**
	 * @unimod.action.descr reduce speed
	 */
	public void z9(StateMachineContext context) {
		myCar.reduceSpeed();
	}

}
