package ru.ifmo.control.manager;

import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 *      (. CarModel3.unimod)
 */
public class CarManager3 extends CarManager2 {

	/**
	 *       .
	 *       {@link #x6}.
	 */
	protected double myT;
	/**
	 *       . 
	 *       {@link #x6}.
	 */
	protected double plT;
	
	/**
	 * @unimod.action.descr is arrive first at point of intersection player car with my car
	 */
	public boolean x6(StateMachineContext context) {	
		double alpha = data.playerCar.getDirectionAngle();	
		double betha = myCar.getDirectionAngle();
		
		/* 
		 * myT -        
		 * plT -        
		 * dx = plT * a + myT * b;
		 * dy = plT * c + myT * d;
		 */
		
		double dx = data.playerCar.getX() - myCar.getX();
		double dy = data.playerCar.getY() - myCar.getY();
		double a =  - data.playerCar.getSpeed() * Math.cos(alpha);
		double b = myCar.getSpeed() * Math.cos(betha);
		double c =  - data.playerCar.getSpeed() * Math.sin(alpha);
		double d = myCar.getSpeed() * Math.sin(betha);
		
		myT = (dy * a - dx * c) / (a * d - b * c);
		if (myT < 0 || Double.isInfinite(myT)) return false;
		
		plT = (dx - myT * b) / a;
		if (plT < 0 || Double.isInfinite(plT)) return false;
		
		return (myT < plT);
	}

}
