package ru.ifmo.control.manager;

import java.awt.geom.Point2D;
import java.util.concurrent.Semaphore;

import ru.ifmo.control.event.CarEventProvider;
import ru.ifmo.control.event.InterceptorEventProvider;

import com.evelopers.unimod.runtime.context.Parameter;
import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 *      .
 */
public class CarManager4 extends CarManager3 {
	
	/**
	 *       
	 */
	protected static Semaphore sem = new Semaphore(2);

	private Point2D intP = new Point2D.Double(); 
	
	/**
	 * @unimod.action.descr time to braking
	 */
	public boolean x7(StateMachineContext context) {
		double dist = Math.hypot(myCar.getX() - intP.getX(), myCar.getY() - intP.getY());
		return dist - myCar.getSpeed() * myCar.getSpeed() / 2 / myCar.getAcceleration() - 
				myCar.getSpeed() * myCar.getWidth() / 2 < 0;
//		return myT <= myCar.getSpeed() / myCar.getAcceleration() + myCar.getSpeed() * myCar.getWidth() / 2;
	}

	/**
	 * @unimod.action.descr invite car to intercept 
	 */
	public void z10(StateMachineContext context) {
		double angle = myCar.getDirectionAngle();
		double x = myCar.getX() + myCar.getSpeed() * Math.cos(angle) * myT;
		double y = myCar.getY() + myCar.getSpeed() * Math.sin(angle) * myT;
		intP.setLocation(x, y);
		
		CarEventProvider.fireEventExceptCar(myCar, InterceptorEventProvider.E6, 
				new Parameter("intercept", intP));
	}

	/**
	 * @unimod.action.descr get intrerception point
	 */
	public void z11(StateMachineContext context) {
		intP = (Point2D)context.getEventContext().getParameter("intercept");
	}
	
	/**
	 * @unimod.action.descr rotate towards intrerception point
	 */
	public void z12(StateMachineContext context) {
		double alpha = Math.atan2((intP.getY() - myCar.getY()), 
				(intP.getX() - myCar.getX()));
		myCar.rotateTo(alpha);
	}

	/**
	 * @unimod.action.descr is x1 || x2 || x3
	 */
	public boolean x123(StateMachineContext context) {
		return x1(context) || x2(context) || x3(context);
	}

	/**
	 * @unimod.action.descr release semaphore
	 */
	public void z13(StateMachineContext context) {
		sem.release();
	}

	/**
	 * @unimod.action.descr is acquire semaphore
	 */
	public boolean x8(StateMachineContext context) {
		return sem.tryAcquire();
	}

	/**
	 * @unimod.action.descr send message to stop interception
	 */
	public void z14(StateMachineContext context) {
		CarEventProvider.fireEventExceptCar(myCar, InterceptorEventProvider.E7);
	}
	
}
