package ru.ifmo.control.manager;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import javax.swing.JFrame;

import ru.ifmo.control.DrawPane;
import ru.ifmo.control.GameGUI;
import ru.ifmo.control.event.ConfigurableTimer;
import ru.ifmo.control.event.GameEventProvider;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 * ,      
 *     .
 */
public class DrawManager extends Manager {

	/**
	 *        .
	 */
	public DrawManager() {
		final JFrame gui = GameGUI.createJFrame();
		if (gui != null) {
			try {
				javax.swing.SwingUtilities.invokeAndWait(new Runnable () {
					public void run() {			
						gui.setVisible(true);
					}
				});
			} catch (InterruptedException e) {
				e.printStackTrace();
				System.exit(1);
			} catch (InvocationTargetException e) {
				e.printStackTrace();
				System.exit(1);
			}
		}
	}
	
	/**
	 * @unimod.action.descr repaint
	 */
	public void z0(StateMachineContext context) {
		data.drawPane.repaint(2 * data.sleepAmount);
	}

	/**
	 * @unimod.action.descr set draw score mode
	 */
	public void z1(StateMachineContext context) {
		data.setDrawScoreMode(true);
	}
	
	/**
	 * @unimod.action.descr set draw game mode
	 */
	public void z2(StateMachineContext context) {
		data.setDrawScoreMode(false);
	}

	/**
	 * @unimod.action.descr is draw score mode
	 */
	public boolean x1(StateMachineContext context) {
		return data.isDrawScoreMode();
	}

	/**
	 * @unimod.action.descr create police engines and start timer
	 */
	public void init(StateMachineContext context) {		
		data = DrawPane.data;
		GameEventProvider.setGameData(data);
		
		try {
			ArrayList<ModelEngine> enemies = data.getModelEngines();
			for (ModelEngine e: enemies) {
				e.start();
			}
		} catch (CommonException e) {
			e.printStackTrace();
			System.exit(1);
		}
		
		ConfigurableTimer.startNewTimer();
	}

}
