package ru.ifmo.control.manager;

import ru.ifmo.control.DrawPane;
import ru.ifmo.control.GameData;
import ru.ifmo.control.GameGUI;
import ru.ifmo.control.event.CarEventProvider;
import ru.ifmo.control.event.GameEventProvider;
import ru.ifmo.control.event.WorldEventProvider;
import ru.ifmo.image.EnemyCar;

import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 *       .
 */
public class GameManager extends Manager {
	
	/**
	 * @unimod.action.descr rotate player
	 */
	public void z1(StateMachineContext context) {
		double alpha = Math.atan2((data.mouseY - data.drawPane.getHeight() / 2), 
				(data.mouseX - data.drawPane.getWidth() / 2));
		data.playerCar.rotateTo(alpha);
	}
	
	/**
	 * @unimod.action.descr move player
	 */
	public void z3(StateMachineContext context) {
		data.playerCar.move();
	}

	/**
	 * @unimod.action.descr change police amount
	 */
	public void z8(StateMachineContext context) {
		GameEventProvider.fireEventLater(WorldEventProvider.E82);
	}

	/**
	 * @unimod.action.descr update score
	 */
	public void z9(StateMachineContext context) {
		GameGUI.scoreField.setText(String.valueOf(GameData.score));
	}

	/**
	 * @unimod.action.descr add three cars to police
	 */
	public void z10(StateMachineContext context) {
		data.increaseEnemiesAmount(3);
		GameEventProvider.fireEventLater(WorldEventProvider.E81);
	}

	/**
	 * @unimod.action.descr add one car to police
	 */
	public void z11(StateMachineContext context) {
		data.increaseEnemiesAmount();
		GameEventProvider.fireEventLater(WorldEventProvider.E81);
	}

	/**
	 * @unimod.action.descr inform cars that game is started
	 */
	public void z12(StateMachineContext context) {
		CarEventProvider.fireEventLater(CarEventProvider.E1);
	}

	/**
	 * @unimod.action.descr inform all cars that program is closed
	 */
	public void z13(StateMachineContext context) {
		CarEventProvider.fireEventLater(CarEventProvider.E2);
	}

	/**
	 * @unimod.action.descr player car collide with police
	 */
	public boolean x1(StateMachineContext context) {
		for (EnemyCar car: data.enemies) {
			if (data.playerCar.intersect(car)) {
				return true;
			}
		}
		return false;
	}

	/**
	 * @unimod.action.descr explode player car
	 */
	public void z2(StateMachineContext context) {
		data.playerCar.explode();
	}

	/**
	 * @unimod.action.descr player car crashing
	 */
	public boolean x2(StateMachineContext context) {
		return data.playerCar.isCrashed();
	}

	/**
	 * @unimod.action.descr police cars amount
	 */
	public int x3(StateMachineContext context) {
		return data.enemies.size();
	}

	/**
	 * @unimod.action.descr add two cars to police
	 */
	public void z7(StateMachineContext context) {
		data.increaseEnemiesAmount(2);
	}

	/**
	 * @unimod.action.descr increase score
	 */
	public void z4(StateMachineContext context) {
		GameData.score++;
	}

	/**
	 * @unimod.action.descr reallocate cars
	 */
	public void z5(StateMachineContext context) {
		DrawPane.data.reallocateCars();
	}

	/**
	 * @unimod.action.descr inform police that next tick heppened
	 */
	public void z6(StateMachineContext context) {
		CarEventProvider.fireEventLater(CarEventProvider.E101);
	}

	/**
	 * @unimod.action.descr stot player car
	 */
	public void z14(StateMachineContext context) {
		data.playerCar.stopCarImmediately();
	}

	/**
	 * @unimod.action.descr decrease score
	 */
	public void z15(StateMachineContext context) {
		GameData.score -= 50;
	}

}
