package ru.ifmo.image;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;

import ru.ifmo.control.GameData;

/**
 *   .
 */
public class Explosion {

	private static BufferedImage[] explosion;
	static {
		try {
			//TODO  -   config.xml
			URLClassLoader urlLoader = (URLClassLoader)Explosion.class.getClassLoader();
			URL fileLoc = urlLoader.findResource("images/boom.gif");
			ImageInputStream iis = ImageIO.createImageInputStream(fileLoc.openStream());
			ImageReader reader = ImageIO.getImageReaders(iis).next();
			reader.setInput(iis);
			
			int num = reader.getNumImages(true);
			explosion = new BufferedImage[num];
			for (int i = 0; i < num; i++) 
				explosion[i] = reader.read(i);
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	/**
	 *     .
	 */
	protected RotatableImage[] image;
	/**
	 *    .
	 */
	protected int pictureNumber = 0;
	
	private double x;
	private double y;
	
	/**
	 *  
	 * @param data  
	 */
	public Explosion(GameData data) {
		image = new RotatableImage[explosion.length];
		for (int i = 0; i < image.length; i++) {
			image[i] = new ExplosionImage(data);
			image[i].setImage(explosion[i]);
		}
	}
	
	/**
	 *     ?
	 * @return
	 */
	public boolean isVisible() {
		return pictureNumber < image.length;
	}
	
	/**
	 *       .
	 * @param g <code>Graphics2D</code>  
	 */
	public void paint(Graphics2D g) {
		if (!isVisible()) return;
		image[pictureNumber].setLocation(x, y);		
		image[pictureNumber++].paint(g);
	}
	
	/**
	 *     (x,y).
	 * @param x    x 
	 * @param y    y
	 */
	public void setLocation(double x, double y) {
		this.x = x;
		this.y = y;
	}
}
