package ru.ifmo.image;

import java.awt.geom.Point2D;

import ru.ifmo.control.GameData;

/**
 *        .
 *     .
 * @see #Explosion
 */
public class ExplosionImage extends RotatableImage {

	private Car playerCar;
	private Point2D player = new Point2D.Double();
	
	/**
	 *  
	 * @param data  
	 */
	public ExplosionImage(GameData data) {
		super(data.drawPane);
		this.playerCar = data.playerCar;
	}

	@Override
	protected void transform() {
		rLock.lock();	
		try {
			playerCar.getLocation(player);
			transform.setToTranslation(x - width / 2 + drawPane.getWidth() / 2 - player.getX(), 
					y - height / 2 + drawPane.getHeight() / 2 - player.getY());
			transform.rotate(angle, width / 2, height / 2);
		} finally {
			rLock.unlock();
		}
	}
}
