package ru.ifmo.image;

import java.io.IOException;

import ru.ifmo.control.GameData;

/**
 * ,   .
 */
public class PlayerCar extends Car {
	
	/**
	 *   : ,    .
	 */
	public enum MotionMode {
		ACCELERATED,	// 
		DECELERATED,	// 
		UNIFORM			// 
	}

	/**
	 *  
	 */
	protected MotionMode mm = MotionMode.ACCELERATED;
	private volatile boolean crashed = false;
	
	/**
	 *  
	 * @param data  
	 * @param filename     
	 * @throws IOException        
	 */
	public PlayerCar(GameData data, String filename) throws IOException {
		super(data, filename);
	}
	
	/**
	 *     .
	 * @param cr true -  , false -    
	 */
	public void setCrashed(boolean cr) {
		crashed = cr;
	}
	
	/**
	 *      .
	 * @return true -  , false -  
	 */
	public boolean isCrashed() {
		return crashed;
	}
	
	/**
	 *   :<br>
	 * <code>MotionMode.ACCELERATED</code> -  ;<br>
	 * <code>MotionMode.DECELERATED</code> -  ;<br>
	 * <code>MotionMode.UNIFORM</code> -   .
	 * 
	 * @param mode  
	 * @see Car.MotionMode
	 */
	public void setMotionMode(MotionMode mode) {
		mm = mode;
	}

	@Override
	public void move() {
		switch (mm) {
		case DECELERATED:
			reduceSpeed();
			break;
		case ACCELERATED:
			speedUp();
			break;	
		}
		move(speed);
	}
	
	@Override
	protected void transform() {
		rLock.lock();
		try {
			transform.setToTranslation(drawPane.getWidth() / 2 - width / 2, 
					drawPane.getHeight() / 2 - height / 2);
			transform.rotate(angle, width / 2, height / 2);
		} finally {
			rLock.unlock();
		}
	}

	@Override
	public void explode() {
		rLock.lock();
		try {
			Explosion expl = new PlayerExplosion(data);
			expl.setLocation(x, y);
			data.explosions.add(expl);
			setCrashed(true);
		} finally {
			rLock.unlock();
		}
	}

}
