/**
  * This file was generated from model [Model1] on [Mon May 21 17:34:52 MSD 2007].
  * Do not change content of this file.
  */
package unimod;

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class Car4ModelEventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int A1 = 1;
			private static final int A2 = 2;
	
	private int decodeStateMachine(String sm) {
					
		if ("A1".equals(sm)) {
			return A1;
						} else 
				
		if ("A2".equals(sm)) {
			return A2;
			}

		return -1;
	}
		
			private A1EventProcessor _A1;
			private A2EventProcessor _A2;
		
	public Car4ModelEventProcessor() {
		modelStructure = new Model1ModelStructure();

					_A1 = new A1EventProcessor();
					_A2 = new A2EventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(Car4ModelEventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		Car4ModelEventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new Car4ModelEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private ru.ifmo.control.manager.CarManager4 o1 = null;
	        private ru.ifmo.control.event.InterceptorEventProvider p1 = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "o1")) {
                		    if (o1 == null) {
                		        o1 = new ru.ifmo.control.manager.CarManager4();
                		    }
                		    return o1;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	                ep = getEventProvider("p1");
                ep.init(engine);
	            }

	            public void dispose() {
	                	EventProvider ep;
		                ep = getEventProvider("p1");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                if (StringUtils.equals(epName, "p1")) {
                		    if (p1 == null) {
                		        p1 = new ru.ifmo.control.event.InterceptorEventProvider();
                		    }
                		    return p1;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_A1.init(controlledObjectsMap);
					_A2.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case A1:
				return _A1.process(event, context, path, config);
					case A2:
				return _A2.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case A1:
				return _A1.transiteToStableState(context, path, config);
					case A2:
				return _A2.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class Model1ModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private Model1ModelStructure() {
		        configManagers.put("A1", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		        configManagers.put("A2", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("A1");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case A1:
                				return new StateMachineConfig("Top");
					            case A2:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case A1:
                				state = _A1.decodeState(config.getActiveState());
				                switch (state) {
																																																																											                    					default:
                    						    return false;
                	}
					            case A2:
                				state = _A2.decodeState(config.getActiveState());
				                switch (state) {
																																																																																				                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class A1EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int crash = 2;
	    private static final int create_new = 3;
	    private static final int move_to_player = 4;
	    private static final int leave_bounds = 5;
	    private static final int s1 = 6;
	    private static final int do_maneuver = 7;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("crash".equals(state)) {
			return crash;
						} else 
				
		if ("create new".equals(state)) {
			return create_new;
						} else 
				
		if ("move to player".equals(state)) {
			return move_to_player;
						} else 
				
		if ("leave bounds".equals(state)) {
			return leave_bounds;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("do maneuver".equals(state)) {
			return do_maneuver;
			}
		
		return -1;
	}
	
		// events
	    private static final int e101 = 1;
	    private static final int e5 = 2;
	    private static final int e1 = 3;
	    private static final int e3 = 4;
	
	private int decodeEvent(String event) {
					
		if ("e101".equals(event)) {
			return e101;
						} else 
				
		if ("e5".equals(event)) {
			return e5;
						} else 
				
		if ("e1".equals(event)) {
			return e1;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
				}
	
		return -1;
	}
		
							private ru.ifmo.control.manager.CarManager4 o1;
							
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (ru.ifmo.control.manager.CarManager4)controlledObjectsMap.getControlledObject("o1");
											}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case crash: 
					
											return;
																					case create_new: 
					
											return;
																					case move_to_player: 
																					// move to player includes A2
	
	fireBeforeSubmachineExecution(context, event, path, "move to player", "A2");
	
	Car4ModelEventProcessor.this.process(event, context, new StateMachinePath(path,
		"move to player", "A2"));

    fireAfterSubmachineExecution(context, event, path, "move to player", "A2");
												
											return;
																					case leave_bounds: 
					
											return;
																					case s1: 
					
											return;
																					case do_maneuver: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A1]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->create new [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#create new##true");
	
		
	fireComeToState(context, path, "create new");
	
	// create new [o1.z7]
				fireBeforeOutputActionExecution(context, path, "s1#create new##true", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "s1#create new##true", "o1.z7");
						
											return new StateMachineConfig("create new");
																																										}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
			boolean
								
			o1_x3 = false
									,
						
			o1_x1 = false
									,
						
			o1_x4 = false
									,
						
			o1_x2 = false
				;
				
		
	
				BitSet calculatedInputActions = new BitSet(4);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case crash:
						
											
												switch (e) {
													case e3:
																
						// crash->create new e3[true]/
			
			fireTransitionCandidate(context, path, "crash", event, "crash#create new#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "crash", event, "crash#create new#e3#true");
	
		
	fireComeToState(context, path, "create new");
	
	// create new [o1.z7]
				fireBeforeOutputActionExecution(context, path, "crash#create new#e3#true", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "crash#create new#e3#true", "o1.z7");
					return new StateMachineConfig("create new");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case create_new:
						
											
												switch (e) {
													case e1:
																
						// create new->move to player e1[true]/
			
			fireTransitionCandidate(context, path, "create new", event, "create new#move to player#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "create new", event, "create new#move to player#e1#true");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player []
					return new StateMachineConfig("move to player");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case move_to_player:
						
											
												switch (e) {
													case e101:
																
						// move to player->crash e101[o1.x3]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#crash#e101#o1.x3");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x3)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.x3");

					o1_x3 = o1.x3(context);
		
			fireAfterInputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.x3", new Boolean(o1_x3));
			}					
							
							
			
												if (o1_x3) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#crash#e101#o1.x3");
	
		
	fireComeToState(context, path, "crash");
	
	// crash [o1.z6, o1.z4]
				fireBeforeOutputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.z6");
				fireBeforeOutputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#crash#e101#o1.x3", "o1.z4");
					return new StateMachineConfig("crash");

									}
												// move to player->leave bounds e101[o1.x2 && !o1.x3]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#leave bounds#e101#o1.x2 && !o1.x3");
			
																								if (!isInputActionCalculated(calculatedInputActions, _o1_x2)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.x2");

					o1_x2 = o1.x2(context);
		
			fireAfterInputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.x2", new Boolean(o1_x2));
			}					
							
							
			
												if (o1_x2 && !o1_x3) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#leave bounds#e101#o1.x2 && !o1.x3");
	
		
	fireComeToState(context, path, "leave bounds");
	
	// leave bounds [o1.z4, o1.z7]
				fireBeforeOutputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.z4");
				fireBeforeOutputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#leave bounds#e101#o1.x2 && !o1.x3", "o1.z7");
					return new StateMachineConfig("leave bounds");

									}
												// move to player->do maneuver e101[o1.x1 && !o1.x2 && !o1.x3]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3");
			
																								if (!isInputActionCalculated(calculatedInputActions, _o1_x1)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.x1");

					o1_x1 = o1.x1(context);
		
			fireAfterInputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.x1", new Boolean(o1_x1));
			}					
														
							
			
												if (o1_x1 && !o1_x2 && !o1_x3) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3");
	
		
	fireComeToState(context, path, "do maneuver");
	
	// do maneuver [o1.z3, o1.z9, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z3");

				o1.z3(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z3");
				fireBeforeOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#do maneuver#e101#o1.x1 && !o1.x2 && !o1.x3", "o1.z1");
					return new StateMachineConfig("do maneuver");

									}
																
										// transition not found
								return config;
																			case e5:
																
						// move to player->crash e5[true]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#crash#e5#true");
			
						
							
			
							
					fireTransitionFound(context, path, "move to player", event, "move to player#crash#e5#true");
	
		
	fireComeToState(context, path, "crash");
	
	// crash [o1.z6, o1.z4]
				fireBeforeOutputActionExecution(context, path, "move to player#crash#e5#true", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#crash#e5#true", "o1.z6");
				fireBeforeOutputActionExecution(context, path, "move to player#crash#e5#true", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#crash#e5#true", "o1.z4");
					return new StateMachineConfig("crash");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case leave_bounds:
						
											
												switch (e) {
													case e101:
																
						// leave bounds->move to player e101[true]/o1.z5
			
			fireTransitionCandidate(context, path, "leave bounds", event, "leave bounds#move to player#e101#true");
			
						
							
			
							
					fireTransitionFound(context, path, "leave bounds", event, "leave bounds#move to player#e101#true");
	
				fireBeforeOutputActionExecution(context, path, "leave bounds#move to player#e101#true", "o1.z5");

				o1.z5(context);
		
	fireAfterOutputActionExecution(context, path, "leave bounds#move to player#e101#true", "o1.z5");
		
	fireComeToState(context, path, "move to player");
	
	// move to player []
					return new StateMachineConfig("move to player");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case do_maneuver:
						
											
												switch (e) {
													case e101:
																
						// do maneuver->crash e101[o1.x3]/
			
			fireTransitionCandidate(context, path, "do maneuver", event, "do maneuver#crash#e101#o1.x3");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x3)) {
	
		fireBeforeInputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.x3");

					o1_x3 = o1.x3(context);
		
			fireAfterInputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.x3", new Boolean(o1_x3));
			}					
							
							
			
												if (o1_x3) {
				
					fireTransitionFound(context, path, "do maneuver", event, "do maneuver#crash#e101#o1.x3");
	
		
	fireComeToState(context, path, "crash");
	
	// crash [o1.z6, o1.z4]
				fireBeforeOutputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.z6");
				fireBeforeOutputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#crash#e101#o1.x3", "o1.z4");
					return new StateMachineConfig("crash");

									}
												// do maneuver->move to player e101[o1.x4 && !o1.x2 && !o1.x3]/
			
			fireTransitionCandidate(context, path, "do maneuver", event, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3");
			
																								if (!isInputActionCalculated(calculatedInputActions, _o1_x4)) {
	
		fireBeforeInputActionExecution(context, path, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3", "o1.x4");

					o1_x4 = o1.x4(context);
		
			fireAfterInputActionExecution(context, path, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3", "o1.x4", new Boolean(o1_x4));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x2)) {
	
		fireBeforeInputActionExecution(context, path, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3", "o1.x2");

					o1_x2 = o1.x2(context);
		
			fireAfterInputActionExecution(context, path, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3", "o1.x2", new Boolean(o1_x2));
			}					
							
							
			
												if (o1_x4 && !o1_x2 && !o1_x3) {
				
					fireTransitionFound(context, path, "do maneuver", event, "do maneuver#move to player#e101#o1.x4 && !o1.x2 && !o1.x3");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player []
					return new StateMachineConfig("move to player");

									}
												// do maneuver->leave bounds e101[o1.x2 && !o1.x3]/
			
			fireTransitionCandidate(context, path, "do maneuver", event, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3");
			
																				
							
			
												if (o1_x2 && !o1_x3) {
				
					fireTransitionFound(context, path, "do maneuver", event, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3");
	
		
	fireComeToState(context, path, "leave bounds");
	
	// leave bounds [o1.z4, o1.z7]
				fireBeforeOutputActionExecution(context, path, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3", "o1.z4");
				fireBeforeOutputActionExecution(context, path, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#leave bounds#e101#o1.x2 && !o1.x3", "o1.z7");
					return new StateMachineConfig("leave bounds");

									}
												// do maneuver->do maneuver e101[!o1.x2 && !o1.x3 && !o1.x4]/
			
			fireTransitionCandidate(context, path, "do maneuver", event, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4");
			
																											
							
			
												if (!o1_x2 && !o1_x3 && !o1_x4) {
				
					fireTransitionFound(context, path, "do maneuver", event, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4");
	
		
	fireComeToState(context, path, "do maneuver");
	
	// do maneuver [o1.z3, o1.z9, o1.z1]
				fireBeforeOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z3");

				o1.z3(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z3");
				fireBeforeOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#do maneuver#e101#!o1.x2 && !o1.x3 && !o1.x4", "o1.z1");
					return new StateMachineConfig("do maneuver");

									}
																
										// transition not found
								return config;
																			case e5:
																
						// do maneuver->crash e5[true]/
			
			fireTransitionCandidate(context, path, "do maneuver", event, "do maneuver#crash#e5#true");
			
						
							
			
							
					fireTransitionFound(context, path, "do maneuver", event, "do maneuver#crash#e5#true");
	
		
	fireComeToState(context, path, "crash");
	
	// crash [o1.z6, o1.z4]
				fireBeforeOutputActionExecution(context, path, "do maneuver#crash#e5#true", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#crash#e5#true", "o1.z6");
				fireBeforeOutputActionExecution(context, path, "do maneuver#crash#e5#true", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "do maneuver#crash#e5#true", "o1.z4");
					return new StateMachineConfig("crash");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A1]");
			}
		}
	}

				//o1.x3
				private static final int _o1_x3 = 0;
			//o1.x1
				private static final int _o1_x1 = 1;
			//o1.x4
				private static final int _o1_x4 = 2;
			//o1.x2
				private static final int _o1_x2 = 3;
	        
}
			







private class A2EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int advance = 2;
	    private static final int move_to_player = 3;
	    private static final int try_semaphore = 4;
	    private static final int s1 = 5;
	    private static final int interception = 6;
	    private static final int braking = 7;
	    private static final int move_to_interception_point = 8;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("advance".equals(state)) {
			return advance;
						} else 
				
		if ("move to player".equals(state)) {
			return move_to_player;
						} else 
				
		if ("try semaphore".equals(state)) {
			return try_semaphore;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("interception".equals(state)) {
			return interception;
						} else 
				
		if ("braking".equals(state)) {
			return braking;
						} else 
				
		if ("move to interception point".equals(state)) {
			return move_to_interception_point;
			}
		
		return -1;
	}
	
		// events
	    private static final int e101 = 1;
	    private static final int e7 = 2;
	    private static final int e6 = 3;
	
	private int decodeEvent(String event) {
					
		if ("e101".equals(event)) {
			return e101;
						} else 
				
		if ("e7".equals(event)) {
			return e7;
						} else 
				
		if ("e6".equals(event)) {
			return e6;
				}
	
		return -1;
	}
		
							private ru.ifmo.control.manager.CarManager4 o1;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (ru.ifmo.control.manager.CarManager4)controlledObjectsMap.getControlledObject("o1");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case advance: 
					
											return;
																					case move_to_player: 
					
											return;
																					case try_semaphore: 
					
											return;
																					case s1: 
					
											return;
																					case interception: 
					
											return;
																					case braking: 
					
											return;
																					case move_to_interception_point: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A2]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->move to player [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#move to player##true");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "s1#move to player##true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "s1#move to player##true", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "s1#move to player##true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "s1#move to player##true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "s1#move to player##true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#move to player##true", "o1.z1");
						
											return new StateMachineConfig("move to player");
																																															}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
			boolean
								
			o1_x6 = false
									,
						
			o1_x5 = false
									,
						
			o1_x7 = false
									,
						
			o1_x123 = false
									,
						
			o1_x8 = false
				;
				
		
	
				BitSet calculatedInputActions = new BitSet(5);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case advance:
						
											
												switch (e) {
													case e101:
																
						// advance->advance e101[!o1.x123 && o1.x5]/
			
			fireTransitionCandidate(context, path, "advance", event, "advance#advance#e101#!o1.x123 && o1.x5");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x5)) {
	
		fireBeforeInputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.x5");

					o1_x5 = o1.x5(context);
		
			fireAfterInputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.x5", new Boolean(o1_x5));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x123)) {
	
		fireBeforeInputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.x123");

					o1_x123 = o1.x123(context);
		
			fireAfterInputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.x123", new Boolean(o1_x123));
			}					
							
							
			
												if (!o1_x123 && o1_x5) {
				
					fireTransitionFound(context, path, "advance", event, "advance#advance#e101#!o1.x123 && o1.x5");
	
		
	fireComeToState(context, path, "advance");
	
	// advance [o1.z1]
				fireBeforeOutputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "advance#advance#e101#!o1.x123 && o1.x5", "o1.z1");
					return new StateMachineConfig("advance");

									}
												// advance->move to player e101[!o1.x123 && !o1.x5 && !o1.x6]/
			
			fireTransitionCandidate(context, path, "advance", event, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x6)) {
	
		fireBeforeInputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6");

					o1_x6 = o1.x6(context);
		
			fireAfterInputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6", new Boolean(o1_x6));
			}					
																					
							
			
												if (!o1_x123 && !o1_x5 && !o1_x6) {
				
					fireTransitionFound(context, path, "advance", event, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "advance#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// advance->try semaphore e101[!o1.x123 && !o1.x5 && o1.x6]/
			
			fireTransitionCandidate(context, path, "advance", event, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6");
			
																											
							
			
												if (!o1_x123 && !o1_x5 && o1_x6) {
				
					fireTransitionFound(context, path, "advance", event, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6");
	
		
	fireComeToState(context, path, "try semaphore");
	
	// try semaphore [o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "advance#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z1");
					return new StateMachineConfig("try semaphore");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case move_to_player:
						
											
												switch (e) {
													case e101:
																
						// move to player->advance e101[!o1.x123 && o1.x5]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#advance#e101#!o1.x123 && o1.x5");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x5)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.x5");

					o1_x5 = o1.x5(context);
		
			fireAfterInputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.x5", new Boolean(o1_x5));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x123)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.x123");

					o1_x123 = o1.x123(context);
		
			fireAfterInputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.x123", new Boolean(o1_x123));
			}					
							
							
			
												if (!o1_x123 && o1_x5) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#advance#e101#!o1.x123 && o1.x5");
	
		
	fireComeToState(context, path, "advance");
	
	// advance [o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#advance#e101#!o1.x123 && o1.x5", "o1.z1");
					return new StateMachineConfig("advance");

									}
												// move to player->move to player e101[!o1.x123 && !o1.x5 && !o1.x6]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x6)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6");

					o1_x6 = o1.x6(context);
		
			fireAfterInputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6", new Boolean(o1_x6));
			}					
																					
							
			
												if (!o1_x123 && !o1_x5 && !o1_x6) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// move to player->try semaphore e101[!o1.x123 && !o1.x5 && o1.x6]/
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6");
			
																											
							
			
												if (!o1_x123 && !o1_x5 && o1_x6) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6");
	
		
	fireComeToState(context, path, "try semaphore");
	
	// try semaphore [o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#try semaphore#e101#!o1.x123 && !o1.x5 && o1.x6", "o1.z1");
					return new StateMachineConfig("try semaphore");

									}
																
										// transition not found
								return config;
																			case e6:
																
						// move to player->move to interception point e6[o1.x8]/o1.z11
			
			fireTransitionCandidate(context, path, "move to player", event, "move to player#move to interception point#e6#o1.x8");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x8)) {
	
		fireBeforeInputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.x8");

					o1_x8 = o1.x8(context);
		
			fireAfterInputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.x8", new Boolean(o1_x8));
			}					
							
							
			
												if (o1_x8) {
				
					fireTransitionFound(context, path, "move to player", event, "move to player#move to interception point#e6#o1.x8");
	
				fireBeforeOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z11");

				o1.z11(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z11");
		
	fireComeToState(context, path, "move to interception point");
	
	// move to interception point [o1.z12, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z12");

				o1.z12(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z12");
				fireBeforeOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to player#move to interception point#e6#o1.x8", "o1.z1");
					return new StateMachineConfig("move to interception point");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case try_semaphore:
						
											
												switch (e) {
													case e101:
																
						// try semaphore->move to player e101[!o1.x8]/
			
			fireTransitionCandidate(context, path, "try semaphore", event, "try semaphore#move to player#e101#!o1.x8");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x8)) {
	
		fireBeforeInputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.x8");

					o1_x8 = o1.x8(context);
		
			fireAfterInputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.x8", new Boolean(o1_x8));
			}					
							
							
			
												if (!o1_x8) {
				
					fireTransitionFound(context, path, "try semaphore", event, "try semaphore#move to player#e101#!o1.x8");
	
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#move to player#e101#!o1.x8", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// try semaphore->interception e101[o1.x8]/o1.z10
			
			fireTransitionCandidate(context, path, "try semaphore", event, "try semaphore#interception#e101#o1.x8");
			
													
							
			
												if (o1_x8) {
				
					fireTransitionFound(context, path, "try semaphore", event, "try semaphore#interception#e101#o1.x8");
	
				fireBeforeOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z10");

				o1.z10(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z10");
		
	fireComeToState(context, path, "interception");
	
	// interception [o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "try semaphore#interception#e101#o1.x8", "o1.z1");
					return new StateMachineConfig("interception");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																													case interception:
						
											
												switch (e) {
													case e101:
																
						// interception->move to player e101[!o1.x123 && !o1.x5 && !o1.x6]/o1.z13,o1.z14
			
			fireTransitionCandidate(context, path, "interception", event, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x6)) {
	
		fireBeforeInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6");

					o1_x6 = o1.x6(context);
		
			fireAfterInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x6", new Boolean(o1_x6));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x5)) {
	
		fireBeforeInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x5");

					o1_x5 = o1.x5(context);
		
			fireAfterInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x5", new Boolean(o1_x5));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x123)) {
	
		fireBeforeInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x123");

					o1_x123 = o1.x123(context);
		
			fireAfterInputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.x123", new Boolean(o1_x123));
			}					
							
							
			
												if (!o1_x123 && !o1_x5 && !o1_x6) {
				
					fireTransitionFound(context, path, "interception", event, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6");
	
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z13");
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z14");

				o1.z14(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z14");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e101#!o1.x123 && !o1.x5 && !o1.x6", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// interception->interception e101[!o1.x123 && !o1.x5 && o1.x6 && !o1.x7]/
			
			fireTransitionCandidate(context, path, "interception", event, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7");
			
																															if (!isInputActionCalculated(calculatedInputActions, _o1_x7)) {
	
		fireBeforeInputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.x7");

					o1_x7 = o1.x7(context);
		
			fireAfterInputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.x7", new Boolean(o1_x7));
			}					
														
							
			
												if (!o1_x123 && !o1_x5 && o1_x6 && !o1_x7) {
				
					fireTransitionFound(context, path, "interception", event, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7");
	
		
	fireComeToState(context, path, "interception");
	
	// interception [o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "interception#interception#e101#!o1.x123 && !o1.x5 && o1.x6 && !o1.x7", "o1.z1");
					return new StateMachineConfig("interception");

									}
												// interception->braking e101[!o1.x123 && !o1.x5 && o1.x6 && o1.x7]/
			
			fireTransitionCandidate(context, path, "interception", event, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7");
			
																																		
							
			
												if (!o1_x123 && !o1_x5 && o1_x6 && o1_x7) {
				
					fireTransitionFound(context, path, "interception", event, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7");
	
		
	fireComeToState(context, path, "braking");
	
	// braking [o1.z9, o1.z1]
				fireBeforeOutputActionExecution(context, path, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "interception#braking#e101#!o1.x123 && !o1.x5 && o1.x6 && o1.x7", "o1.z1");
					return new StateMachineConfig("braking");

									}
																
										// transition not found
								return config;
																			case e7:
																
						// interception->move to player e7[true]/o1.z13
			
			fireTransitionCandidate(context, path, "interception", event, "interception#move to player#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "interception", event, "interception#move to player#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z13");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to player#e7#true", "o1.z1");
					return new StateMachineConfig("move to player");

																				
														case e6:
																
						// interception->move to interception point e6[true]/o1.z11
			
			fireTransitionCandidate(context, path, "interception", event, "interception#move to interception point#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "interception", event, "interception#move to interception point#e6#true");
	
				fireBeforeOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z11");

				o1.z11(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z11");
		
	fireComeToState(context, path, "move to interception point");
	
	// move to interception point [o1.z12, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z12");

				o1.z12(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z12");
				fireBeforeOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "interception#move to interception point#e6#true", "o1.z1");
					return new StateMachineConfig("move to interception point");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case braking:
						
											
												switch (e) {
													case e101:
																
						// braking->move to player e101[!o1.x123 && !o1.x6]/o1.z13,o1.z14
			
			fireTransitionCandidate(context, path, "braking", event, "braking#move to player#e101#!o1.x123 && !o1.x6");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x6)) {
	
		fireBeforeInputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.x6");

					o1_x6 = o1.x6(context);
		
			fireAfterInputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.x6", new Boolean(o1_x6));
			}					
																		if (!isInputActionCalculated(calculatedInputActions, _o1_x123)) {
	
		fireBeforeInputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.x123");

					o1_x123 = o1.x123(context);
		
			fireAfterInputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.x123", new Boolean(o1_x123));
			}					
							
							
			
												if (!o1_x123 && !o1_x6) {
				
					fireTransitionFound(context, path, "braking", event, "braking#move to player#e101#!o1.x123 && !o1.x6");
	
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z13");
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z14");

				o1.z14(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z14");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e101#!o1.x123 && !o1.x6", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// braking->braking e101[!o1.x123 && o1.x6]/
			
			fireTransitionCandidate(context, path, "braking", event, "braking#braking#e101#!o1.x123 && o1.x6");
			
																				
							
			
												if (!o1_x123 && o1_x6) {
				
					fireTransitionFound(context, path, "braking", event, "braking#braking#e101#!o1.x123 && o1.x6");
	
		
	fireComeToState(context, path, "braking");
	
	// braking [o1.z9, o1.z1]
				fireBeforeOutputActionExecution(context, path, "braking#braking#e101#!o1.x123 && o1.x6", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "braking#braking#e101#!o1.x123 && o1.x6", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "braking#braking#e101#!o1.x123 && o1.x6", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "braking#braking#e101#!o1.x123 && o1.x6", "o1.z1");
					return new StateMachineConfig("braking");

									}
																
										// transition not found
								return config;
																			case e7:
																
						// braking->move to player e7[true]/o1.z13
			
			fireTransitionCandidate(context, path, "braking", event, "braking#move to player#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "braking", event, "braking#move to player#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z13");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "braking#move to player#e7#true", "o1.z1");
					return new StateMachineConfig("move to player");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case move_to_interception_point:
						
											
												switch (e) {
													case e101:
																
						// move to interception point->move to player e101[o1.x123]/o1.z13
			
			fireTransitionCandidate(context, path, "move to interception point", event, "move to interception point#move to player#e101#o1.x123");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x123)) {
	
		fireBeforeInputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.x123");

					o1_x123 = o1.x123(context);
		
			fireAfterInputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.x123", new Boolean(o1_x123));
			}					
							
							
			
												if (o1_x123) {
				
					fireTransitionFound(context, path, "move to interception point", event, "move to interception point#move to player#e101#o1.x123");
	
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z13");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e101#o1.x123", "o1.z1");
					return new StateMachineConfig("move to player");

									}
												// move to interception point->braking e101[!o1.x123 && o1.x7]/
			
			fireTransitionCandidate(context, path, "move to interception point", event, "move to interception point#braking#e101#!o1.x123 && o1.x7");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o1_x7)) {
	
		fireBeforeInputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.x7");

					o1_x7 = o1.x7(context);
		
			fireAfterInputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.x7", new Boolean(o1_x7));
			}					
														
							
			
												if (!o1_x123 && o1_x7) {
				
					fireTransitionFound(context, path, "move to interception point", event, "move to interception point#braking#e101#!o1.x123 && o1.x7");
	
		
	fireComeToState(context, path, "braking");
	
	// braking [o1.z9, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.z9");

				o1.z9(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.z9");
				fireBeforeOutputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#braking#e101#!o1.x123 && o1.x7", "o1.z1");
					return new StateMachineConfig("braking");

									}
												// move to interception point->move to interception point e101[!o1.x123 && !o1.x7]/
			
			fireTransitionCandidate(context, path, "move to interception point", event, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7");
			
																				
							
			
												if (!o1_x123 && !o1_x7) {
				
					fireTransitionFound(context, path, "move to interception point", event, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7");
	
		
	fireComeToState(context, path, "move to interception point");
	
	// move to interception point [o1.z12, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z12");

				o1.z12(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z12");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e101#!o1.x123 && !o1.x7", "o1.z1");
					return new StateMachineConfig("move to interception point");

									}
																
										// transition not found
								return config;
																			case e7:
																
						// move to interception point->move to player e7[true]/o1.z13
			
			fireTransitionCandidate(context, path, "move to interception point", event, "move to interception point#move to player#e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "move to interception point", event, "move to interception point#move to player#e7#true");
	
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z13");
		
	fireComeToState(context, path, "move to player");
	
	// move to player [o1.z2, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to player#e7#true", "o1.z1");
					return new StateMachineConfig("move to player");

																				
														case e6:
																
						// move to interception point->move to interception point e6[true]/o1.z11
			
			fireTransitionCandidate(context, path, "move to interception point", event, "move to interception point#move to interception point#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "move to interception point", event, "move to interception point#move to interception point#e6#true");
	
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z11");

				o1.z11(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z11");
		
	fireComeToState(context, path, "move to interception point");
	
	// move to interception point [o1.z12, o1.z8, o1.z1]
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z12");

				o1.z12(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z12");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z8");
				fireBeforeOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "move to interception point#move to interception point#e6#true", "o1.z1");
					return new StateMachineConfig("move to interception point");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A2]");
			}
		}
	}

				//o1.x6
				private static final int _o1_x6 = 0;
			//o1.x5
				private static final int _o1_x5 = 1;
			//o1.x7
				private static final int _o1_x7 = 2;
			//o1.x123
				private static final int _o1_x123 = 3;
			//o1.x8
				private static final int _o1_x8 = 4;
	        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
