/**
  * This file was generated from model [Model1] on [Mon May 21 17:58:02 MSD 2007].
  * Do not change content of this file.
  */
package unimod;

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class GameModelEventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int A1 = 1;
			private static final int A2 = 2;
			private static final int A3 = 3;
	
	private int decodeStateMachine(String sm) {
					
		if ("A1".equals(sm)) {
			return A1;
						} else 
				
		if ("A2".equals(sm)) {
			return A2;
						} else 
				
		if ("A3".equals(sm)) {
			return A3;
			}

		return -1;
	}
		
			private A1EventProcessor _A1;
			private A2EventProcessor _A2;
			private A3EventProcessor _A3;
		
	public GameModelEventProcessor() {
		modelStructure = new Model1ModelStructure();

					_A1 = new A1EventProcessor();
					_A2 = new A2EventProcessor();
					_A3 = new A3EventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(GameModelEventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		GameModelEventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new GameModelEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private ru.ifmo.control.manager.DrawManager o1 = null;
	        private ru.ifmo.control.manager.GameManager o2 = null;
	        private com.evelopers.unimod.adapter.standalone.co.Counter o4 = null;
	        private ru.ifmo.control.manager.RandomWalkManager o3 = null;
	        private ru.ifmo.control.event.UserEventProvider p2 = null;
	        private ru.ifmo.control.event.ConfigurableTimer p1 = null;
	        private ru.ifmo.control.event.WorldEventProvider p3 = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "o1")) {
                		    if (o1 == null) {
                		        o1 = new ru.ifmo.control.manager.DrawManager();
                		    }
                		    return o1;
                }
                if (StringUtils.equals(coName, "o2")) {
                		    if (o2 == null) {
                		        o2 = new ru.ifmo.control.manager.GameManager();
                		    }
                		    return o2;
                }
                if (StringUtils.equals(coName, "o4")) {
                		    if (o4 == null) {
                		        o4 = new com.evelopers.unimod.adapter.standalone.co.Counter();
                		    }
                		    return o4;
                }
                if (StringUtils.equals(coName, "o3")) {
                		    if (o3 == null) {
                		        o3 = new ru.ifmo.control.manager.RandomWalkManager();
                		    }
                		    return o3;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	                ep = getEventProvider("p2");
                ep.init(engine);
	                ep = getEventProvider("p1");
                ep.init(engine);
	                ep = getEventProvider("p3");
                ep.init(engine);
	            }

	            public void dispose() {
	                	EventProvider ep;
		                ep = getEventProvider("p2");
                ep.dispose();
	                ep = getEventProvider("p1");
                ep.dispose();
	                ep = getEventProvider("p3");
                ep.dispose();
                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                if (StringUtils.equals(epName, "p2")) {
                		    if (p2 == null) {
                		        p2 = new ru.ifmo.control.event.UserEventProvider();
                		    }
                		    return p2;
                }
                if (StringUtils.equals(epName, "p1")) {
                		    if (p1 == null) {
                		        p1 = new ru.ifmo.control.event.ConfigurableTimer();
                		    }
                		    return p1;
                }
                if (StringUtils.equals(epName, "p3")) {
                		    if (p3 == null) {
                		        p3 = new ru.ifmo.control.event.WorldEventProvider();
                		    }
                		    return p3;
                }
                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_A1.init(controlledObjectsMap);
					_A2.init(controlledObjectsMap);
					_A3.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case A1:
				return _A1.process(event, context, path, config);
					case A2:
				return _A2.process(event, context, path, config);
					case A3:
				return _A3.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case A1:
				return _A1.transiteToStableState(context, path, config);
					case A2:
				return _A2.transiteToStableState(context, path, config);
					case A3:
				return _A3.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class Model1ModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private Model1ModelStructure() {
		        configManagers.put("A1", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		        configManagers.put("A2", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		        configManagers.put("A3", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("A1");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case A1:
                				return new StateMachineConfig("Top");
					            case A2:
                				return new StateMachineConfig("Top");
					            case A3:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case A1:
                				state = _A1.decodeState(config.getActiveState());
				                switch (state) {
																												                    case A1EventProcessor.s2:
																																																															                        return true;
				                    					default:
                    						    return false;
                	}
					            case A2:
                				state = _A2.decodeState(config.getActiveState());
				                switch (state) {
																																																																		                    					default:
                    						    return false;
                	}
					            case A3:
                				state = _A3.decodeState(config.getActiveState());
				                switch (state) {
																																																                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class A1EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s2 = 2;
	    private static final int Stop = 3;
	    private static final int Pause = 4;
	    private static final int s1 = 5;
	    private static final int Start = 6;
	    private static final int doWait = 7;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s2".equals(state)) {
			return s2;
						} else 
				
		if ("Stop".equals(state)) {
			return Stop;
						} else 
				
		if ("Pause".equals(state)) {
			return Pause;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("Start".equals(state)) {
			return Start;
						} else 
				
		if ("doWait".equals(state)) {
			return doWait;
			}
		
		return -1;
	}
	
		// events
	    private static final int e4 = 1;
	    private static final int e2 = 2;
	    private static final int e5 = 3;
	    private static final int e1 = 4;
	    private static final int e3 = 5;
	    private static final int e6 = 6;
	
	private int decodeEvent(String event) {
					
		if ("e4".equals(event)) {
			return e4;
						} else 
				
		if ("e2".equals(event)) {
			return e2;
						} else 
				
		if ("e5".equals(event)) {
			return e5;
						} else 
				
		if ("e1".equals(event)) {
			return e1;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
						} else 
				
		if ("e6".equals(event)) {
			return e6;
				}
	
		return -1;
	}
		
							private ru.ifmo.control.manager.DrawManager o1;
								private ru.ifmo.control.manager.GameManager o2;
							
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (ru.ifmo.control.manager.DrawManager)controlledObjectsMap.getControlledObject("o1");
												o2 = (ru.ifmo.control.manager.GameManager)controlledObjectsMap.getControlledObject("o2");
											}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s2: 
					
											return;
																					case Stop: 
					
											return;
																					case Pause: 
					
											return;
																					case s1: 
					
											return;
																					case Start: 
																					// Start includes A2
	
	fireBeforeSubmachineExecution(context, event, path, "Start", "A2");
	
	GameModelEventProcessor.this.process(event, context, new StateMachinePath(path,
		"Start", "A2"));

    fireAfterSubmachineExecution(context, event, path, "Start", "A2");
												
											return;
																					case doWait: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A1]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->Stop [true]/o1.init
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#Stop##true");
	
				fireBeforeOutputActionExecution(context, path, "s1#Stop##true", "o1.init");

				o1.init(context);
		
	fireAfterOutputActionExecution(context, path, "s1#Stop##true", "o1.init");
		
	fireComeToState(context, path, "Stop");
	
	// Stop []
						
											return new StateMachineConfig("Stop");
																																										}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case Stop:
						
											
												switch (e) {
													case e4:
																
						// Stop->s2 e4[true]/o2.z13
			
			fireTransitionCandidate(context, path, "Stop", event, "Stop#s2#e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Stop", event, "Stop#s2#e4#true");
	
				fireBeforeOutputActionExecution(context, path, "Stop#s2#e4#true", "o2.z13");

				o2.z13(context);
		
	fireAfterOutputActionExecution(context, path, "Stop#s2#e4#true", "o2.z13");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e1:
																
						// Stop->Start e1[true]/o2.z12
			
			fireTransitionCandidate(context, path, "Stop", event, "Stop#Start#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Stop", event, "Stop#Start#e1#true");
	
				fireBeforeOutputActionExecution(context, path, "Stop#Start#e1#true", "o2.z12");

				o2.z12(context);
		
	fireAfterOutputActionExecution(context, path, "Stop#Start#e1#true", "o2.z12");
		
	fireComeToState(context, path, "Start");
	
	// Start []
					return new StateMachineConfig("Start");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Pause:
						
											
												switch (e) {
													case e4:
																
						// Pause->s2 e4[true]/o2.z13
			
			fireTransitionCandidate(context, path, "Pause", event, "Pause#s2#e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Pause", event, "Pause#s2#e4#true");
	
				fireBeforeOutputActionExecution(context, path, "Pause#s2#e4#true", "o2.z13");

				o2.z13(context);
		
	fireAfterOutputActionExecution(context, path, "Pause#s2#e4#true", "o2.z13");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e2:
																
						// Pause->Start e2[true]/
			
			fireTransitionCandidate(context, path, "Pause", event, "Pause#Start#e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Pause", event, "Pause#Start#e2#true");
	
		
	fireComeToState(context, path, "Start");
	
	// Start []
					return new StateMachineConfig("Start");

																				
														case e1:
																
						// Pause->Start e1[true]/o2.z5,o1.z0
			
			fireTransitionCandidate(context, path, "Pause", event, "Pause#Start#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Pause", event, "Pause#Start#e1#true");
	
				fireBeforeOutputActionExecution(context, path, "Pause#Start#e1#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Pause#Start#e1#true", "o2.z5");
				fireBeforeOutputActionExecution(context, path, "Pause#Start#e1#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "Pause#Start#e1#true", "o1.z0");
		
	fireComeToState(context, path, "Start");
	
	// Start []
					return new StateMachineConfig("Start");

																				
														case e3:
																
						// Pause->Stop e3[true]/o2.z5,o1.z0
			
			fireTransitionCandidate(context, path, "Pause", event, "Pause#Stop#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Pause", event, "Pause#Stop#e3#true");
	
				fireBeforeOutputActionExecution(context, path, "Pause#Stop#e3#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Pause#Stop#e3#true", "o2.z5");
				fireBeforeOutputActionExecution(context, path, "Pause#Stop#e3#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "Pause#Stop#e3#true", "o1.z0");
		
	fireComeToState(context, path, "Stop");
	
	// Stop []
					return new StateMachineConfig("Stop");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case Start:
						
											
												switch (e) {
													case e4:
																
						// Start->s2 e4[true]/o2.z13
			
			fireTransitionCandidate(context, path, "Start", event, "Start#s2#e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Start", event, "Start#s2#e4#true");
	
				fireBeforeOutputActionExecution(context, path, "Start#s2#e4#true", "o2.z13");

				o2.z13(context);
		
	fireAfterOutputActionExecution(context, path, "Start#s2#e4#true", "o2.z13");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e2:
																
						// Start->Pause e2[true]/
			
			fireTransitionCandidate(context, path, "Start", event, "Start#Pause#e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Start", event, "Start#Pause#e2#true");
	
		
	fireComeToState(context, path, "Pause");
	
	// Pause []
					return new StateMachineConfig("Pause");

																				
														case e1:
																
						// Start->Start e1[true]/o2.z5,o1.z0
			
			fireTransitionCandidate(context, path, "Start", event, "Start#Start#e1#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Start", event, "Start#Start#e1#true");
	
				fireBeforeOutputActionExecution(context, path, "Start#Start#e1#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Start#e1#true", "o2.z5");
				fireBeforeOutputActionExecution(context, path, "Start#Start#e1#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Start#e1#true", "o1.z0");
		
	fireComeToState(context, path, "Start");
	
	// Start []
					return new StateMachineConfig("Start");

																				
														case e3:
																
						// Start->Stop e3[true]/o2.z5,o1.z0
			
			fireTransitionCandidate(context, path, "Start", event, "Start#Stop#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Start", event, "Start#Stop#e3#true");
	
				fireBeforeOutputActionExecution(context, path, "Start#Stop#e3#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Stop#e3#true", "o2.z5");
				fireBeforeOutputActionExecution(context, path, "Start#Stop#e3#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Stop#e3#true", "o1.z0");
		
	fireComeToState(context, path, "Stop");
	
	// Stop []
					return new StateMachineConfig("Stop");

																				
														case e6:
																
						// Start->doWait e6[true]/
			
			fireTransitionCandidate(context, path, "Start", event, "Start#doWait#e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Start", event, "Start#doWait#e6#true");
	
		
	fireComeToState(context, path, "doWait");
	
	// doWait []
					return new StateMachineConfig("doWait");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case doWait:
						
											
												switch (e) {
													case e4:
																
						// doWait->s2 e4[true]/o2.z13
			
			fireTransitionCandidate(context, path, "doWait", event, "doWait#s2#e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "doWait", event, "doWait#s2#e4#true");
	
				fireBeforeOutputActionExecution(context, path, "doWait#s2#e4#true", "o2.z13");

				o2.z13(context);
		
	fireAfterOutputActionExecution(context, path, "doWait#s2#e4#true", "o2.z13");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e5:
																
						// doWait->Start e5[true]/
			
			fireTransitionCandidate(context, path, "doWait", event, "doWait#Start#e5#true");
			
						
							
			
							
					fireTransitionFound(context, path, "doWait", event, "doWait#Start#e5#true");
	
		
	fireComeToState(context, path, "Start");
	
	// Start []
					return new StateMachineConfig("Start");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A1]");
			}
		}
	}

		        
}
			







private class A2EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int DrawScore = 2;
	    private static final int PlayerCrash = 3;
	    private static final int DoTurn = 4;
	    private static final int s1 = 5;
	    private static final int PoliceCrash = 6;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("DrawScore".equals(state)) {
			return DrawScore;
						} else 
				
		if ("PlayerCrash".equals(state)) {
			return PlayerCrash;
						} else 
				
		if ("DoTurn".equals(state)) {
			return DoTurn;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("PoliceCrash".equals(state)) {
			return PoliceCrash;
			}
		
		return -1;
	}
	
		// events
	    private static final int e81 = 1;
	    private static final int e101 = 2;
	    private static final int e80 = 3;
	    private static final int e102 = 4;
	
	private int decodeEvent(String event) {
					
		if ("e81".equals(event)) {
			return e81;
						} else 
				
		if ("e101".equals(event)) {
			return e101;
						} else 
				
		if ("e80".equals(event)) {
			return e80;
						} else 
				
		if ("e102".equals(event)) {
			return e102;
				}
	
		return -1;
	}
		
							private ru.ifmo.control.manager.DrawManager o1;
								private ru.ifmo.control.manager.GameManager o2;
								private com.evelopers.unimod.adapter.standalone.co.Counter o4;
							
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (ru.ifmo.control.manager.DrawManager)controlledObjectsMap.getControlledObject("o1");
												o2 = (ru.ifmo.control.manager.GameManager)controlledObjectsMap.getControlledObject("o2");
												o4 = (com.evelopers.unimod.adapter.standalone.co.Counter)controlledObjectsMap.getControlledObject("o4");
											}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case DrawScore: 
					
											return;
																					case PlayerCrash: 
					
											return;
																					case DoTurn: 
					
											return;
																					case s1: 
					
											return;
																					case PoliceCrash: 
																					// PoliceCrash includes A3
	
	fireBeforeSubmachineExecution(context, event, path, "PoliceCrash", "A3");
	
	GameModelEventProcessor.this.process(event, context, new StateMachinePath(path,
		"PoliceCrash", "A3"));

    fireAfterSubmachineExecution(context, event, path, "PoliceCrash", "A3");
												
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A2]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->DoTurn [true]/o2.z14
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#DoTurn##true");
	
				fireBeforeOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z14");

				o2.z14(context);
		
	fireAfterOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z14");
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "s1#DoTurn##true", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "s1#DoTurn##true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "s1#DoTurn##true", "o1.z0");
						
											return new StateMachineConfig("DoTurn");
																																					}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
			boolean
								
			o2_x1 = false
									,
						
			o2_x2 = false
				;
				
		
			int
								
			o2_x3 = 0
									,
						
			o4_x4 = 0
				;
	
				BitSet calculatedInputActions = new BitSet(4);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case DrawScore:
						
											
												switch (e) {
													case e101:
																
						// DrawScore->DrawScore e101[o4.x4 < 30]/o4.z2
			
			fireTransitionCandidate(context, path, "DrawScore", event, "DrawScore#DrawScore#e101#o4.x4 < 30");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o4_x4)) {
	
		fireBeforeInputActionExecution(context, path, "DrawScore#DrawScore#e101#o4.x4 < 30", "o4.x4");

					o4_x4 = o4.x4(context);

			fireAfterInputActionExecution(context, path, "DrawScore#DrawScore#e101#o4.x4 < 30", "o4.x4", new Integer(o4_x4));
			}					
							
							
			
												if (o4_x4 < 30) {
				
					fireTransitionFound(context, path, "DrawScore", event, "DrawScore#DrawScore#e101#o4.x4 < 30");
	
				fireBeforeOutputActionExecution(context, path, "DrawScore#DrawScore#e101#o4.x4 < 30", "o4.z2");

				o4.z2(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DrawScore#e101#o4.x4 < 30", "o4.z2");
		
	fireComeToState(context, path, "DrawScore");
	
	// DrawScore []
					return new StateMachineConfig("DrawScore");

									}
												// DrawScore->DoTurn e101[o4.x4 >= 30]/o2.z5,o1.z2,o1.z0
			
			fireTransitionCandidate(context, path, "DrawScore", event, "DrawScore#DoTurn#e101#o4.x4 >= 30");
			
													
							
			
												if (o4_x4 >= 30) {
				
					fireTransitionFound(context, path, "DrawScore", event, "DrawScore#DoTurn#e101#o4.x4 >= 30");
	
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z5");
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z2");
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z0");
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DrawScore#DoTurn#e101#o4.x4 >= 30", "o1.z0");
					return new StateMachineConfig("DoTurn");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case PlayerCrash:
						
											
												switch (e) {
													case e101:
																
						// PlayerCrash->DrawScore e101[!o2.x2]/o4.z1,o1.z1,o1.z0
			
			fireTransitionCandidate(context, path, "PlayerCrash", event, "PlayerCrash#DrawScore#e101#!o2.x2");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o2_x2)) {
	
		fireBeforeInputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o2.x2");

					o2_x2 = o2.x2(context);
		
			fireAfterInputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o2.x2", new Boolean(o2_x2));
			}					
							
							
			
												if (!o2_x2) {
				
					fireTransitionFound(context, path, "PlayerCrash", event, "PlayerCrash#DrawScore#e101#!o2.x2");
	
				fireBeforeOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o4.z1");

				o4.z1(context);
		
	fireAfterOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o4.z1");
				fireBeforeOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o1.z1");
				fireBeforeOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "PlayerCrash#DrawScore#e101#!o2.x2", "o1.z0");
		
	fireComeToState(context, path, "DrawScore");
	
	// DrawScore []
					return new StateMachineConfig("DrawScore");

									}
												// PlayerCrash->PlayerCrash e101[o2.x2]/
			
			fireTransitionCandidate(context, path, "PlayerCrash", event, "PlayerCrash#PlayerCrash#e101#o2.x2");
			
													
							
			
												if (o2_x2) {
				
					fireTransitionFound(context, path, "PlayerCrash", event, "PlayerCrash#PlayerCrash#e101#o2.x2");
	
		
	fireComeToState(context, path, "PlayerCrash");
	
	// PlayerCrash [o2.z6, o1.z0]
				fireBeforeOutputActionExecution(context, path, "PlayerCrash#PlayerCrash#e101#o2.x2", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "PlayerCrash#PlayerCrash#e101#o2.x2", "o2.z6");
				fireBeforeOutputActionExecution(context, path, "PlayerCrash#PlayerCrash#e101#o2.x2", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "PlayerCrash#PlayerCrash#e101#o2.x2", "o1.z0");
					return new StateMachineConfig("PlayerCrash");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case DoTurn:
						
											
												switch (e) {
													case e101:
																
						// DoTurn->PlayerCrash e101[o2.x1]/o2.z2,o2.z14,o2.z15,o2.z9
			
			fireTransitionCandidate(context, path, "DoTurn", event, "DoTurn#PlayerCrash#e101#o2.x1");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o2_x1)) {
	
		fireBeforeInputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.x1");

					o2_x1 = o2.x1(context);
		
			fireAfterInputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.x1", new Boolean(o2_x1));
			}					
							
							
			
												if (o2_x1) {
				
					fireTransitionFound(context, path, "DoTurn", event, "DoTurn#PlayerCrash#e101#o2.x1");
	
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z2");

				o2.z2(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z2");
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z14");

				o2.z14(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z14");
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z15");

				o2.z15(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z15");
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z9");

				o2.z9(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z9");
		
	fireComeToState(context, path, "PlayerCrash");
	
	// PlayerCrash [o2.z6, o1.z0]
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o2.z6");
				fireBeforeOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PlayerCrash#e101#o2.x1", "o1.z0");
					return new StateMachineConfig("PlayerCrash");

									}
												// DoTurn->DoTurn e101[o2.x3 < 3 && !o2.x1]/o2.z6,o2.z7
			
			fireTransitionCandidate(context, path, "DoTurn", event, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o2_x3)) {
	
		fireBeforeInputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.x3");

					o2_x3 = o2.x3(context);

			fireAfterInputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.x3", new Integer(o2_x3));
			}					
														
							
			
												if (o2_x3 < 3 && !o2_x1) {
				
					fireTransitionFound(context, path, "DoTurn", event, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1");
	
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z6");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z7");

				o2.z7(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z7");
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#o2.x3 < 3 && !o2.x1", "o1.z0");
					return new StateMachineConfig("DoTurn");

									}
												// DoTurn->DoTurn e101[!o2.x1 && o2.x3 >= 3]/o2.z6
			
			fireTransitionCandidate(context, path, "DoTurn", event, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3");
			
																				
							
			
												if (!o2_x1 && o2_x3 >= 3) {
				
					fireTransitionFound(context, path, "DoTurn", event, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3");
	
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z6");
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e101#!o2.x1 && o2.x3 >= 3", "o1.z0");
					return new StateMachineConfig("DoTurn");

									}
																
										// transition not found
								return config;
																			case e80:
																
						// DoTurn->PoliceCrash e80[true]/
			
			fireTransitionCandidate(context, path, "DoTurn", event, "DoTurn#PoliceCrash#e80#true");
			
						
							
			
							
					fireTransitionFound(context, path, "DoTurn", event, "DoTurn#PoliceCrash#e80#true");
	
		
	fireComeToState(context, path, "PoliceCrash");
	
	// PoliceCrash [o2.z9, o2.z8]
				fireBeforeOutputActionExecution(context, path, "DoTurn#PoliceCrash#e80#true", "o2.z9");

				o2.z9(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PoliceCrash#e80#true", "o2.z9");
				fireBeforeOutputActionExecution(context, path, "DoTurn#PoliceCrash#e80#true", "o2.z8");

				o2.z8(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#PoliceCrash#e80#true", "o2.z8");
					return new StateMachineConfig("PoliceCrash");

																				
														case e102:
																
						// DoTurn->DoTurn e102[true]/o2.z6,o2.z4,o2.z9
			
			fireTransitionCandidate(context, path, "DoTurn", event, "DoTurn#DoTurn#e102#true");
			
						
							
			
							
					fireTransitionFound(context, path, "DoTurn", event, "DoTurn#DoTurn#e102#true");
	
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z6");

				o2.z6(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z6");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z4");

				o2.z4(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z4");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z9");

				o2.z9(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z9");
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "DoTurn#DoTurn#e102#true", "o1.z0");
					return new StateMachineConfig("DoTurn");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case PoliceCrash:
						
											
												switch (e) {
													case e81:
																
						// PoliceCrash->DoTurn e81[true]/
			
			fireTransitionCandidate(context, path, "PoliceCrash", event, "PoliceCrash#DoTurn#e81#true");
			
						
							
			
							
					fireTransitionFound(context, path, "PoliceCrash", event, "PoliceCrash#DoTurn#e81#true");
	
		
	fireComeToState(context, path, "DoTurn");
	
	// DoTurn [o2.z1, o2.z3, o1.z0]
				fireBeforeOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o2.z1");

				o2.z1(context);
		
	fireAfterOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o2.z1");
				fireBeforeOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o2.z3");
				fireBeforeOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "PoliceCrash#DoTurn#e81#true", "o1.z0");
					return new StateMachineConfig("DoTurn");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A2]");
			}
		}
	}

				//o2.x3
				private static final int _o2_x3 = 0;
			//o2.x1
				private static final int _o2_x1 = 1;
			//o4.x4
				private static final int _o4_x4 = 2;
			//o2.x2
				private static final int _o2_x2 = 3;
	        
}
			







private class A3EventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int stateP = 2;
	    private static final int stateQ = 3;
	    private static final int s1 = 4;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("stateP".equals(state)) {
			return stateP;
						} else 
				
		if ("stateQ".equals(state)) {
			return stateQ;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
			}
		
		return -1;
	}
	
		// events
	    private static final int e82 = 1;
	
	private int decodeEvent(String event) {
					
		if ("e82".equals(event)) {
			return e82;
				}
	
		return -1;
	}
		
							private ru.ifmo.control.manager.GameManager o2;
								private ru.ifmo.control.manager.RandomWalkManager o3;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o2 = (ru.ifmo.control.manager.GameManager)controlledObjectsMap.getControlledObject("o2");
												o3 = (ru.ifmo.control.manager.RandomWalkManager)controlledObjectsMap.getControlledObject("o3");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case stateP: 
					
											return;
																					case stateQ: 
					
											return;
																					case s1: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [A3]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->stateP [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#stateP##true");
	
		
	fireComeToState(context, path, "stateP");
	
	// stateP [o2.z10]
				fireBeforeOutputActionExecution(context, path, "s1#stateP##true", "o2.z10");

				o2.z10(context);
		
	fireAfterOutputActionExecution(context, path, "s1#stateP##true", "o2.z10");
						
											return new StateMachineConfig("stateP");
																											}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
			boolean
								
			o3_q = false
									,
						
			o3_p = false
				;
				
		
	
				BitSet calculatedInputActions = new BitSet(2);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																			case stateP:
						
											
												switch (e) {
													case e82:
																
						// stateP->stateP e82[!o3.p]/
			
			fireTransitionCandidate(context, path, "stateP", event, "stateP#stateP#e82#!o3.p");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o3_p)) {
	
		fireBeforeInputActionExecution(context, path, "stateP#stateP#e82#!o3.p", "o3.p");

					o3_p = o3.p(context);
		
			fireAfterInputActionExecution(context, path, "stateP#stateP#e82#!o3.p", "o3.p", new Boolean(o3_p));
			}					
							
							
			
												if (!o3_p) {
				
					fireTransitionFound(context, path, "stateP", event, "stateP#stateP#e82#!o3.p");
	
		
	fireComeToState(context, path, "stateP");
	
	// stateP [o2.z10]
				fireBeforeOutputActionExecution(context, path, "stateP#stateP#e82#!o3.p", "o2.z10");

				o2.z10(context);
		
	fireAfterOutputActionExecution(context, path, "stateP#stateP#e82#!o3.p", "o2.z10");
					return new StateMachineConfig("stateP");

									}
												// stateP->stateQ e82[o3.p]/
			
			fireTransitionCandidate(context, path, "stateP", event, "stateP#stateQ#e82#o3.p");
			
													
							
			
												if (o3_p) {
				
					fireTransitionFound(context, path, "stateP", event, "stateP#stateQ#e82#o3.p");
	
		
	fireComeToState(context, path, "stateQ");
	
	// stateQ [o2.z11]
				fireBeforeOutputActionExecution(context, path, "stateP#stateQ#e82#o3.p", "o2.z11");

				o2.z11(context);
		
	fireAfterOutputActionExecution(context, path, "stateP#stateQ#e82#o3.p", "o2.z11");
					return new StateMachineConfig("stateQ");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																						case stateQ:
						
											
												switch (e) {
													case e82:
																
						// stateQ->stateP e82[o3.q]/
			
			fireTransitionCandidate(context, path, "stateQ", event, "stateQ#stateP#e82#o3.q");
			
																	if (!isInputActionCalculated(calculatedInputActions, _o3_q)) {
	
		fireBeforeInputActionExecution(context, path, "stateQ#stateP#e82#o3.q", "o3.q");

					o3_q = o3.q(context);
		
			fireAfterInputActionExecution(context, path, "stateQ#stateP#e82#o3.q", "o3.q", new Boolean(o3_q));
			}					
							
							
			
												if (o3_q) {
				
					fireTransitionFound(context, path, "stateQ", event, "stateQ#stateP#e82#o3.q");
	
		
	fireComeToState(context, path, "stateP");
	
	// stateP [o2.z10]
				fireBeforeOutputActionExecution(context, path, "stateQ#stateP#e82#o3.q", "o2.z10");

				o2.z10(context);
		
	fireAfterOutputActionExecution(context, path, "stateQ#stateP#e82#o3.q", "o2.z10");
					return new StateMachineConfig("stateP");

									}
												// stateQ->stateQ e82[!o3.q]/
			
			fireTransitionCandidate(context, path, "stateQ", event, "stateQ#stateQ#e82#!o3.q");
			
													
							
			
												if (!o3_q) {
				
					fireTransitionFound(context, path, "stateQ", event, "stateQ#stateQ#e82#!o3.q");
	
		
	fireComeToState(context, path, "stateQ");
	
	// stateQ [o2.z11]
				fireBeforeOutputActionExecution(context, path, "stateQ#stateQ#e82#!o3.q", "o2.z11");

				o2.z11(context);
		
	fireAfterOutputActionExecution(context, path, "stateQ#stateQ#e82#!o3.q", "o2.z11");
					return new StateMachineConfig("stateQ");

									}
																
										// transition not found
								return config;
																		default:
														
							
										// transition not found
								return config;
												}
						
																								default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [A3]");
			}
		}
	}

				//o3.q
				private static final int _o3_q = 0;
			//o3.p
				private static final int _o3_p = 1;
	        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
